import TIM from 'tim-js-sdk';
import store from '@/store/index.js'

var options = {
	SDKAppID: 1400448522 // 即时通信应用的 SDKAppID
};
// 创建 SDK 实例，TIM.create() 方法对于同一个 SDKAppID 只会返回同一份实例
var tim = TIM.create(options); // SDK 实例通常用 tim 表示

export default {
	
	//格式化时间戳
	timestampToTime(cjsj) {
		// console.log(cjsj)
			var date = new Date(cjsj) //时间戳为10位需*1000，时间戳为13位的话不需乘1000
			// console.log(date)
			var Y = date.getFullYear() + '-'
			var M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '-'
			var D = date.getDate() + ' '
			var h = date.getHours() + ':'
			var m = date.getMinutes() + ':'
			var s = date.getSeconds()
			return Y+M+D+h+m+s
	},
	// 更新个人资料
	updateMyProfile(data){
		// console.log(data)
		let promise = tim.updateMyProfile(data);
		promise.then(function(imResponse) {
		  // console.log(imResponse.data); // 更新资料成功
		}).catch(function(imError) {
		  console.warn('updateMyProfile error:', imError); // 更新资料失败的相关信息
		});
	},
	// 消息已读
	setMessageRead(conversationID){
		let that = this
		let MessageRead = tim.setMessageRead({conversationID: conversationID});
		MessageRead.then(function(imResponse) {
			// console.log('已读上报成功')
			store.commit('setmsgBoom','minus')
			that.sationList()
			// 已读上报成功，指定 ID 的会话的 unreadCount 属性值被置为0
		}).catch(function(imError) {
			// 已读上报失败
			console.warn('已读上报失败:', imError);
		});
	},
	// 获取消息列表
	sationList(){
		// console.log('获取消息列表')
		let Conversationlist = store.getters.conversationList
		let chat = store.getters.myCsInfo
		// console.log('获取消息列表',chat,Conversationlist)
		let promise = tim.getConversationList();
		promise.then((res) => {
			Conversationlist = res.data.conversationList
			// console.log(Conversationlist)
			if (Conversationlist.length) {
				store.commit("updateConversationList", Conversationlist);
				Conversationlist.map((item) => {
					if(item.userProfile.userID == chat.userid){
						store.commit("setBoom", item.unreadCount);
						return
					}
					if(item.unreadCount){
						uni.showTabBarRedDot({
							index: 3,
							text: ''
						});
					}
				})
			}
		}).catch((err) => {
			// console.warn('getConversationList error:', err); // 获取会话列表失败的相关信息
		});
	},
	
	//TIM退出
	timislogout(){
		let promise = tim.logout();
		promise.then(function(imResponse) {
		  // console.log(imResponse); // 登出成功
		}).catch(function(imError) {
		  console.warn('logout error:', imError);
		});
	},
	//连接TIM
	timislogin(URL,userid){
		let that = this;
		
		if(!userid){
			return
		}
		this.request(URL, 'GET', { userid: userid }).then(res => {
			console.info(res, '用户userSig');
			if(res[1].statusCode == 200){
				let userSig = res[1].data
				uni.setStorageSync('wenhuuserSig',userSig);//存了好像无用
				// console.log(userid)
				let promise = tim.login({
					userID: userid,
					userSig: userSig
				});
				// console.log('继续执行')
				promise.then((data) => {
					//登录成功后 更新登录状态
					console.info(data,'登录成功')
					uni.setStorageSync('userTIMInfo', JSON.stringify(data.data))
					
				}).catch((err) => {
					console.warn('login error:', err); // 登录失败的相关信息
				});
			}
		});
	},
	gotochat(url,type) {
		let that = this;
		// #ifndef APP-PLUS
		uni.showModal({
			title: '提示',
			content: '请前去APP中与专属客服联系，确认跳转下载页面',
			showCancel: false,
			success() {
				that.gotodetail('/pages/setter/download');
			}
		})
		return
		// #endif
		this.haslogin()
		
		let chat = store.getters.myCsInfo
		// console.log(store.getters.myCsInfo)
		if(chat.userid){
			if(type){
				chat.goods = 'true'
			}
			store.commit('createConversationActive',chat.userid)
			this.gotodetail('/pages/chat/chat', chat);
		}else{
			uni.showModal({
				title: '提示',
				content: '暂无专属客服，重新登录获取专属客服。',
				position: 'center',
				showCancel: true,
				confirmText: "重新登录",
				success: (e) => {
					if (e.confirm) {
						setTimeout(function(){
							that.logout()
						},1000)
					}
				}
			});
		}
		
	},
	// 检测版本
	checkForUpdates(){
		let data = {
			appChannel: 1,
			phoneType: plus.runtime.version
		}
		return uni.request({
			url: this.URL.checkForUpdates,
			method: 'GET',
			networkTimeout: 6000,
			data: data
		});
	},
	bannerinfo(id){
		this.request(this.apiurl + '/index/bannerDetails','GET',{bannerId:id}).then(res => {
			uni.setStorageSync('introduce',res[1].data)
			this.gotodetail('/pages/potGroup/introduce')
		})
	},
	// 接口
	request(url,method,data,type){
		let header = {
				Authorization: uni.getStorageSync('wenhutoken'),
			}
		if(type === '1'){
			header['content-type'] = 'application/x-www-form-urlencoded'
		}
		return uni.request({
			url: url,
			method: method,
			networkTimeout: 6000,
			header: header,
			data: data
		});
	},
	// 隐藏手机号
	phone(mobile){
		if(mobile){
			let reg = /^(\d{3})\d{4}(\d{4})$/
			return mobile.replace(reg, '$1****$2')
		}
	},
	// 倒计时
	countdown(time) {
		let date1 = new Date(); //当前时间  
		let date2 = new Date(time); //结束时间  
		// #ifdef APP-PLUS
		date2 = new Date(time.replace(/-/g, '/')); //结束时间
		// #endif
		
		let date3 = date2.getTime() - date1.getTime(); //时间差        

		//计算天
		let days = Math.floor(date3 / (24 * 3600 * 1000))
		//计算小时
		let leave1 = date3 % (24 * 3600 * 1000)
		let hours = Math.floor(leave1 / (3600 * 1000))
		//计算分钟
		let leave2 = leave1 % (3600 * 1000)  
		let minutes = Math.floor(leave2 / (60 * 1000))
		//计算秒
		let leave3 = leave2 % (60 * 1000)  
		let seconds = Math.round(leave3 / 1000)
		if(hours>=0){
			return days + "天" + hours + "时" + minutes + '分'
		}else{
			return '已结束'
		}
	},
	// 清空登录信息
	logout() {
		uni.setStorageSync('wenhutoken', '');
		uni.setStorageSync('wenhuuserInfo', '');
		this.timislogout()
		// this.$mysocket.closeWebSocket()
		uni.navigateTo({
			url: '/pages/login/login'
		});
	},
	// 验证是否登录
	haslogin() {
		const token = uni.getStorageSync('wenhutoken')
		if (token === undefined || token.length === 0) {
			uni.showToast({
				icon: 'none',
				title: '请登录',
				duration: 3000
			});
			uni.navigateTo({
				url: '/pages/login/login'
			})
		} else {
			uni.hideToast()
			return true;
		}
	},
	// 跳转页面
	gotodetail(url, data) {
		let action = url
		if (JSON.stringify(data)) {
			action = action + '?data=' + JSON.stringify(data)
		}
		uni.navigateTo({
			url: action
		});
	},
	// 跳转tab页面
	gotoTab(url, data) {
		let action = url
		if (data) {
			action = action + '?data=' + data
		}
		uni.switchTab({
			url: action
		})
	},
	tojsonc(msg) {
		let a  = JSON.parse(msg);	
		return a;
	},
	
	tojson(msg) {
		let a  = JSON.parse(msg);	
		return a;
	},
	updateTimeScchow(time) {
		let dat = "";
		
		dat = time;		
		return dat.substring(10,0)
	},
	// 设置导航标题
	setNavTitle(data) {
		uni.setNavigationBarTitle({
			title: data
		});
	},
	datetiME(){
		 let localTime = new Date(); //当前系统时间
		let month = localTime.getMonth()+1;
		let day = localTime.getDate();
		if(month<10){
			month = '0'+month
		}
		if(day<10){
			day = '0'+day
		}
		return 	month + '-' + day
	},
	
	// 时间格式化
	updateTimeShow(time) {
		let that = this
		
		return time.substring(11,5)
		// const JUST_NOW = 3000; //3s内
		// const IN_SECOND = 1000 * 60; //一分钟
		// const IN_MINUTE = 1000 * 60 * 60; //一小时
		// const IN_HOUR = 1000 * 60 * 60 * 12; //12小时
		// const IN_DAY = 1000 * 60 * 60 * 24 * 1; //1天
		// const IN_MONTH = 1000 * 60 * 60 * 24 * 30; //1个月

		// let localTime = new Date(); //当前系统时间
		// let createTime = new Date(time) //消息创建时间
		// let create = new Date(time.substring(0, 10))
		// let local = new Date(localTime.getFullYear() + '-' + (localTime.getMonth() + 1) + '-' + localTime.getDate())
		// let d = local - create
		// let diff = localTime - createTime;
		// if (diff <= JUST_NOW)
		// 	return '刚刚';
		// else if (diff <= IN_SECOND)
		// 	return "1分钟内";
		// else if (diff <= IN_MINUTE)
		// 	return parseInt(diff / IN_SECOND) + '分钟前';
		// else if (diff <= IN_MINUTE)
		// 	return parseInt(diff / IN_MINUTE) + '小时前';
		// else if (d < 57600000) {
		// 	const list = createTime.toString().split(" ");
		// 	const lastIndex = list[4].lastIndexOf(":")
		// 	const realtime = list[4].toString().substring(0, lastIndex);
		// 	return realtime;
		// } else if (d == 57600000) {
		// 	return '昨天';
		// } else if (d < 57600000) {
		// 	return '前天';
		// } else if (diff < IN_DAY * 7) {
		// 	if (diff < IN_DAY) {
		// 		return parseInt(diff / IN_HOUR) + '天前';
		// 	}
		// 	const t = createTime.toString().slice(0, 3);
		// 	switch (t) {
		// 		case "Mon":
		// 			return '星期一';
		// 		case "Tue":
		// 			return '星期二';
		// 		case "Wed":
		// 			return '星期三';
		// 		case "Thu":
		// 			return '星期四';
		// 		case "Fri":
		// 			return '星期五';
		// 		case "Sat":
		// 			return '星期六';
		// 		case "Sun":
		// 			return '星期日';
		// 	}
		// } else if (diff < IN_MONTH * 24) {
		// 	const list = createTime.toString().split(" ");
		// 	const month = list[1];
		// 	var realtime = "";
		// 	if (diff < IN_MONTH) {
		// 		realtime += that.getNumberMonth(month);
		// 	} else {
		// 		realtime = list[3] + "-" + that.getNumberMonth(month);
		// 	}
		// 	return realtime + "-" + list[2];
		// }
	},
	getNumberMonth(month) {
		switch (month) {
			case "Jan":
				return "01";
			case "Feb":
				return "02";
			case "Mar":
				return "03";
			case "Apr":
				return "04";
			case "May":
				return "05";
			case "Jun":
				return "06";
			case "Jul":
				return "07";
			case "Aug":
				return "08";
			case "Sep":
				return "09";
			case "Oct":
				return "10";
			case "Nov":
				return "11";
			case "Dec":
				return "12";
		}
	},
	// 验证手机号码
	checkPhone(data) {
		let reg = /^1([38][0-9]|4[579]|5[0-3,5-9]|6[6]|7[0135678]|9[89])\d{8}$/;
		return reg.test(data)
	},
	// 清除头尾双引号
	replace(data) {
		return data.replace("\"", "").replace("\"", "")
	},
	// 获取朋友圈详情
	getcircle(id) {
		uni.request({
			url: this.apiurl + '/circle/oneFriendCircle?circleid=' + id,
			method: 'GET',
			networkTimeout: 6000,
			header: {
				Authorization: uni.getStorageSync('wenhutoken')
			},
			success: res => {
				if (res.statusCode === 200) {
					// this.gotodetail('/pages/tabBar/home/dynamic', res.data);
				}
			},
			fail: err => {
				uni.showToast({
					icon: 'none',
					position: 'bottom',
					title: err.message,
					duration: 3000
				});
			}
		});
	},
	// 工艺师主页个人主页
	isArtist(data) {
		if (data.userid === uni.getStorageSync('wenhuuserInfo').userid) {
			uni.reLaunch({
				url: '/pages/tabBar/mines/index'
			});
			return
		}
		if (!data.isArtist) {
			this.gotodetail('/pages/tabBar/mines/others', data.userid)
		} else {
			this.gotodetail('/pages/artistDetail/artistDetail', data.userid)
		}
	}
}
